from itertools import chain

TERRITORIAL_ORGANIZATION = {u'01': {'name': u'Tarapac\xe1',
                                    'provinces': {u'011': {'name': u'Iquique',
                                                           'communes': {u'01101': u'Iquique',
                                                                        u'01107': u'Alto Hospicio'}},
                                                  u'014': {'name': u'Tamarugal',
                                                           'communes': {u'01401': u'Pozo Almonte',
                                                                        u'01402': u'Cami\xf1a',
                                                                        u'01403': u'Colchane',
                                                                        u'01404': u'Huara',
                                                                        u'01405': u'Pica'}}}},
                            u'02': {'name': u'Antofagasta',
                                    'provinces': {u'021': {'name': u'Antofagasta',
                                                           'communes': {u'02101': u'Antofagasta',
                                                                        u'02102': u'Mejillones',
                                                                        u'02103': u'Sierra Gorda',
                                                                        u'02104': u'Taltal'}},
                                                  u'022': {'name': u'El Loa',
                                                           'communes': {u'02201': u'Calama',
                                                                        u'02202': u'Ollag\xfce',
                                                                        u'02203': u'San Pedro de Atacama'}},
                                                  u'023': {'name': u'Tocopilla',
                                                           'communes': {u'02301': u'Tocopilla',
                                                                        u'02302': u'Mar\xeda Elena'}}}},
                            u'03': {'name': u'Atacama',
                                    'provinces': {u'031': {'name': u'Copiap\xf3',
                                                           'communes': {u'03101': u'Copiap\xf3',
                                                                        u'03102': u'Caldera',
                                                                        u'03103': u'Tierra Amarilla'}},
                                                  u'032': {'name': u'Cha\xf1aral',
                                                           'communes': {u'03201': u'Cha\xf1aral',
                                                                        u'03202': u'Diego de Almagro'}},
                                                  u'033': {'name': u'Huasco',
                                                           'communes': {u'03301': u'Vallenar',
                                                                        u'03302': u'Alto del Carmen',
                                                                        u'03303': u'Freirina',
                                                                        u'03304': u'Huasco'}}}},
                            u'04': {'name': u'Coquimbo',
                                    'provinces': {u'041': {'name': u'Elqui',
                                                           'communes': {u'04101': u'La Serena',
                                                                        u'04102': u'Coquimbo',
                                                                        u'04103': u'Andacollo',
                                                                        u'04104': u'La Higuera',
                                                                        u'04105': u'Paiguano',
                                                                        u'04106': u'Vicu\xf1a'}},
                                                  u'042': {'name': u'Choapa',
                                                           'communes': {u'04201': u'Illapel',
                                                                        u'04202': u'Canela',
                                                                        u'04203': u'Los Vilos',
                                                                        u'04204': u'Salamanca'}},
                                                  u'043': {'name': u'Limar\xed',
                                                           'communes': {u'04301': u'Ovalle',
                                                                        u'04302': u'Combarbal\xe1',
                                                                        u'04303': u'Monte Patria',
                                                                        u'04304': u'Punitaqui',
                                                                        u'04305': u'R\xedo Hurtado'}}}},
                            u'05': {'name': u'Valpara\xedso',
                                    'provinces': {u'051': {'name': u'Valpara\xedso',
                                                           'communes': {u'05101': u'Valpara\xedso',
                                                                        u'05102': u'Casablanca',
                                                                        u'05103': u'Conc\xf3n',
                                                                        u'05104': u'Juan Fern\xe1ndez',
                                                                        u'05105': u'Puchuncav\xed',
                                                                        u'05107': u'Quintero',
                                                                        u'05109': u'Vi\xf1a del Mar'}},
                                                  u'052': {'name': u'Isla de Pascua',
                                                           'communes': {u'05201': u'Isla de Pascua'}},
                                                  u'053': {'name': u'Los Andes',
                                                           'communes': {u'05301': u'Los Andes',
                                                                        u'05302': u'Calle Larga',
                                                                        u'05303': u'Rinconada',
                                                                        u'05304': u'San Esteban'}},
                                                  u'054': {'name': u'Petorca',
                                                           'communes': {u'05401': u'La Ligua',
                                                                        u'05402': u'Cabildo',
                                                                        u'05403': u'Papudo',
                                                                        u'05404': u'Petorca',
                                                                        u'05405': u'Zapallar'}},
                                                  u'055': {'name': u'Quillota',
                                                           'communes': {u'05501': u'Quillota',
                                                                        u'05502': u'Calera',
                                                                        u'05503': u'Hijuelas',
                                                                        u'05504': u'La Cruz',
                                                                        u'05506': u'Nogales'}},
                                                  u'056': {'name': u'San Antonio',
                                                           'communes': {u'05601': u'San Antonio',
                                                                        u'05602': u'Algarrobo',
                                                                        u'05603': u'Cartagena',
                                                                        u'05604': u'El Quisco',
                                                                        u'05605': u'El Tabo',
                                                                        u'05606': u'Santo Domingo'}},
                                                  u'057': {'name': u'San Felipe de Aconcagua',
                                                           'communes': {u'05701': u'San Felipe',
                                                                        u'05702': u'Catemu',
                                                                        u'05703': u'Llaillay',
                                                                        u'05704': u'Panquehue',
                                                                        u'05705': u'Putaendo',
                                                                        u'05706': u'Santa Mar\xeda'}},
                                                  u'058': {'name': u'Marga Marga',
                                                           'communes': {u'05801': u'Quilpu\xe9',
                                                                        u'05802': u'Limache',
                                                                        u'05803': u'Olmu\xe9',
                                                                        u'05804': u'Villa Alemana'}}}},
                            u'06': {'name': u'Regi\xf3n del Libertador Gral. Bernardo O\u2019Higgins',
                                    'provinces': {u'061': {'name': u'Cachapoal',
                                                           'communes': {u'06101': u'Rancagua',
                                                                        u'06102': u'Codegua',
                                                                        u'06103': u'Coinco',
                                                                        u'06104': u'Coltauco',
                                                                        u'06105': u'Do\xf1ihue',
                                                                        u'06106': u'Graneros',
                                                                        u'06107': u'Las Cabras',
                                                                        u'06108': u'Machal\xed',
                                                                        u'06109': u'Malloa',
                                                                        u'06110': u'Mostazal',
                                                                        u'06111': u'Olivar',
                                                                        u'06112': u'Peumo',
                                                                        u'06113': u'Pichidegua',
                                                                        u'06114': u'Quinta de Tilcoco',
                                                                        u'06115': u'Rengo',
                                                                        u'06116': u'Requ\xednoa',
                                                                        u'06117': u'San Vicente'}},
                                                  u'062': {'name': u'Cardenal Caro',
                                                           'communes': {u'06201': u'Pichilemu',
                                                                        u'06202': u'La Estrella',
                                                                        u'06203': u'Litueche',
                                                                        u'06204': u'Marchihue',
                                                                        u'06205': u'Navidad',
                                                                        u'06206': u'Paredones'}},
                                                  u'063': {'name': u'Colchagua',
                                                           'communes': {u'06301': u'San Fernando',
                                                                        u'06302': u'Ch\xe9pica',
                                                                        u'06303': u'Chimbarongo',
                                                                        u'06304': u'Lolol',
                                                                        u'06305': u'Nancagua',
                                                                        u'06306': u'Palmilla',
                                                                        u'06307': u'Peralillo',
                                                                        u'06308': u'Placilla',
                                                                        u'06309': u'Pumanque',
                                                                        u'06310': u'Santa Cruz'}}}},
                            u'07': {'name': u'Regi\xf3n del Maule',
                                    'provinces': {u'071': {'name': u'Talca',
                                                           'communes': {u'07101': u'Talca',
                                                                        u'07102': u'Constituci\xf3n',
                                                                        u'07103': u'Curepto',
                                                                        u'07104': u'Empedrado',
                                                                        u'07105': u'Maule',
                                                                        u'07106': u'Pelarco',
                                                                        u'07107': u'Pencahue',
                                                                        u'07108': u'R\xedo Claro',
                                                                        u'07109': u'San Clemente',
                                                                        u'07110': u'San Rafael'}},
                                                  u'072': {'name': u'Cauquenes',
                                                           'communes': {u'07201': u'Cauquenes',
                                                                        u'07202': u'Chanco',
                                                                        u'07203': u'Pelluhue'}},
                                                  u'073': {'name': u'Curic\xf3',
                                                           'communes': {u'07301': u'Curic\xf3',
                                                                        u'07302': u'Huala\xf1\xe9',
                                                                        u'07303': u'Licant\xe9n',
                                                                        u'07304': u'Molina',
                                                                        u'07305': u'Rauco',
                                                                        u'07306': u'Romeral',
                                                                        u'07307': u'Sagrada Familia',
                                                                        u'07308': u'Teno',
                                                                        u'07309': u'Vichuqu\xe9n'}},
                                                  u'074': {'name': u'Linares',
                                                           'communes': {u'07401': u'Linares',
                                                                        u'07402': u'Colb\xfan',
                                                                        u'07403': u'Longav\xed',
                                                                        u'07404': u'Parral',
                                                                        u'07405': u'Retiro',
                                                                        u'07406': u'San Javier',
                                                                        u'07407': u'Villa Alegre',
                                                                        u'07408': u'Yerbas Buenas'}}}},
                            u'08': {'name': u'Regi\xf3n del Biob\xedo',
                                    'provinces': {u'081': {'name': u'Concepci\xf3n',
                                                           'communes': {u'08101': u'Concepci\xf3n',
                                                                        u'08102': u'Coronel',
                                                                        u'08103': u'Chiguayante',
                                                                        u'08104': u'Florida',
                                                                        u'08105': u'Hualqui',
                                                                        u'08106': u'Lota',
                                                                        u'08107': u'Penco',
                                                                        u'08108': u'San Pedro de la Paz',
                                                                        u'08109': u'Santa Juana',
                                                                        u'08110': u'Talcahuano',
                                                                        u'08111': u'Tom\xe9',
                                                                        u'08112': u'Hualp\xe9n'}},
                                                  u'082': {'name': u'Arauco',
                                                           'communes': {u'08201': u'Lebu',
                                                                        u'08202': u'Arauco',
                                                                        u'08203': u'Ca\xf1ete',
                                                                        u'08204': u'Contulmo',
                                                                        u'08205': u'Curanilahue',
                                                                        u'08206': u'Los \xc1lamos',
                                                                        u'08207': u'Tir\xfaa'}},
                                                  u'083': {'name': u'Biob\xedo',
                                                           'communes': {u'08301': u'Los \xc1ngeles',
                                                                        u'08302': u'Antuco',
                                                                        u'08303': u'Cabrero',
                                                                        u'08304': u'Laja',
                                                                        u'08305': u'Mulch\xe9n',
                                                                        u'08306': u'Nacimiento',
                                                                        u'08307': u'Negrete',
                                                                        u'08308': u'Quilaco',
                                                                        u'08309': u'Quilleco',
                                                                        u'08310': u'San Rosendo',
                                                                        u'08311': u'Santa B\xe1rbara',
                                                                        u'08312': u'Tucapel',
                                                                        u'08313': u'Yumbel',
                                                                        u'08314': u'Alto Biob\xedo'}},
                                                  u'084': {'name': u'\xd1uble',
                                                           'communes': {u'08401': u'Chill\xe1n',
                                                                        u'08402': u'Bulnes',
                                                                        u'08403': u'Cobquecura',
                                                                        u'08404': u'Coelemu',
                                                                        u'08405': u'Coihueco',
                                                                        u'08406': u'Chill\xe1n Viejo',
                                                                        u'08407': u'El Carmen',
                                                                        u'08408': u'Ninhue',
                                                                        u'08409': u'\xd1iqu\xe9n',
                                                                        u'08410': u'Pemuco',
                                                                        u'08411': u'Pinto',
                                                                        u'08412': u'Portezuelo',
                                                                        u'08413': u'Quill\xf3n',
                                                                        u'08414': u'Quirihue',
                                                                        u'08415': u'R\xe1nquil',
                                                                        u'08416': u'San Carlos',
                                                                        u'08417': u'San Fabi\xe1n',
                                                                        u'08418': u'San Ignacio',
                                                                        u'08419': u'San Nicol\xe1s',
                                                                        u'08420': u'Treguaco',
                                                                        u'08421': u'Yungay'}}}},
                            u'09': {'name': u'Regi\xf3n de la Araucan\xeda',
                                    'provinces': {u'091': {'name': u'Caut\xedn',
                                                           'communes': {u'09101': u'Temuco',
                                                                        u'09102': u'Carahue',
                                                                        u'09103': u'Cunco',
                                                                        u'09104': u'Curarrehue',
                                                                        u'09105': u'Freire',
                                                                        u'09106': u'Galvarino',
                                                                        u'09107': u'Gorbea',
                                                                        u'09108': u'Lautaro',
                                                                        u'09109': u'Loncoche',
                                                                        u'09110': u'Melipeuco',
                                                                        u'09111': u'Nueva Imperial',
                                                                        u'09112': u'Padre las Casas',
                                                                        u'09113': u'Perquenco',
                                                                        u'09114': u'Pitrufqu\xe9n',
                                                                        u'09115': u'Puc\xf3n',
                                                                        u'09116': u'Saavedra',
                                                                        u'09117': u'Teodoro Schmidt',
                                                                        u'09118': u'Tolt\xe9n',
                                                                        u'09119': u'Vilc\xfan',
                                                                        u'09120': u'Villarrica',
                                                                        u'09121': u'Cholchol'}},
                                                  u'092': {'name': u'Malleco',
                                                           'communes': {u'09201': u'Angol',
                                                                        u'09202': u'Collipulli',
                                                                        u'09203': u'Curacaut\xedn',
                                                                        u'09204': u'Ercilla',
                                                                        u'09205': u'Lonquimay',
                                                                        u'09206': u'Los Sauces',
                                                                        u'09207': u'Lumaco',
                                                                        u'09208': u'Pur\xe9n',
                                                                        u'09209': u'Renaico',
                                                                        u'09210': u'Traigu\xe9n',
                                                                        u'09211': u'Victoria'}}}},
                            u'10': {'name': u'Regi\xf3n de Los Lagos',
                                    'provinces': {u'101': {'name': u'Llanquihue',
                                                           'communes': {u'10101': u'Puerto Montt',
                                                                        u'10102': u'Calbuco',
                                                                        u'10103': u'Cocham\xf3',
                                                                        u'10104': u'Fresia',
                                                                        u'10105': u'Frutillar',
                                                                        u'10106': u'Los Muermos',
                                                                        u'10107': u'Llanquihue',
                                                                        u'10108': u'Maull\xedn',
                                                                        u'10109': u'Puerto Varas'}},
                                                  u'102': {'name': u'Chilo\xe9',
                                                           'communes': {u'10201': u'Castro',
                                                                        u'10202': u'Ancud',
                                                                        u'10203': u'Chonchi',
                                                                        u'10204': u'Curaco de V\xe9lez',
                                                                        u'10205': u'Dalcahue',
                                                                        u'10206': u'Puqueld\xf3n',
                                                                        u'10207': u'Queil\xe9n',
                                                                        u'10208': u'Quell\xf3n',
                                                                        u'10209': u'Quemchi',
                                                                        u'10210': u'Quinchao'}},
                                                  u'103': {'name': u'Osorno',
                                                           'communes': {u'10301': u'Osorno',
                                                                        u'10302': u'Puerto Octay',
                                                                        u'10303': u'Purranque',
                                                                        u'10304': u'Puyehue',
                                                                        u'10305': u'R\xedo Negro',
                                                                        u'10306': u'San Juan de la Costa',
                                                                        u'10307': u'San Pablo'}},
                                                  u'104': {'name': u'Palena',
                                                           'communes': {u'10401': u'Chait\xe9n',
                                                                        u'10402': u'Futaleuf\xfa',
                                                                        u'10403': u'Hualaihu\xe9',
                                                                        u'10404': u'Palena'}}}},
                            u'11': {'name': u'Regi\xf3n Ais\xe9n del Gral. Carlos Ib\xe1\xf1ez del Campo',
                                    'provinces': {u'111': {'name': u'Coihaique',
                                                           'communes': {u'11101': u'Coihaique',
                                                                        u'11102': u'Lago Verde'}},
                                                  u'112': {'name': u'Ais\xe9n',
                                                           'communes': {u'11201': u'Ais\xe9n',
                                                                        u'11202': u'Cisnes',
                                                                        u'11203': u'Guaitecas'}},
                                                  u'113': {'name': u'Capit\xe1n Prat',
                                                           'communes': {u'11301': u'Cochrane',
                                                                        u'11302': u'O\u2019Higgins',
                                                                        u'11303': u'Tortel'}},
                                                  u'114': {'name': u'General Carrera',
                                                           'communes': {u'11401': u'Chile Chico',
                                                                        u'11402': u'R\xedo Ib\xe1\xf1ez'}}}},
                            u'12': {'name': u'Regi\xf3n de Magallanes y de la Ant\xe1rtica Chilena',
                                    'provinces': {u'121': {'name': u'Magallanes',
                                                           'communes': {u'12101': u'Punta Arenas',
                                                                        u'12102': u'Laguna Blanca',
                                                                        u'12103': u'R\xedo Verde',
                                                                        u'12104': u'San Gregorio'}},
                                                  u'122': {'name': u'Ant\xe1rtica Chilena',
                                                           'communes': {u'12201': u'Cabo de Hornos (Ex Navarino)',
                                                                        u'12202': u'Ant\xe1rtica'}},
                                                  u'123': {'name': u'Tierra del Fuego',
                                                           'communes': {u'12301': u'Porvenir',
                                                                        u'12302': u'Primavera',
                                                                        u'12303': u'Timaukel'}},
                                                  u'124': {'name': u'\xdaltima Esperanza',
                                                           'communes': {u'12401': u'Natales',
                                                                        u'12402': u'Torres del Paine'}}}},
                            u'13': {'name': u'Regi\xf3n Metropolitana de Santiago',
                                    'provinces': {u'131': {'name': u'Santiago',
                                                           'communes': {u'13101': u'Santiago',
                                                                        u'13102': u'Cerrillos',
                                                                        u'13103': u'Cerro Navia',
                                                                        u'13104': u'Conchal\xed',
                                                                        u'13105': u'El Bosque',
                                                                        u'13106': u'Estaci\xf3n Central',
                                                                        u'13107': u'Huechuraba',
                                                                        u'13108': u'Independencia',
                                                                        u'13109': u'La Cisterna',
                                                                        u'13110': u'La Florida',
                                                                        u'13111': u'La Granja',
                                                                        u'13112': u'La Pintana',
                                                                        u'13113': u'La Reina',
                                                                        u'13114': u'Las Condes',
                                                                        u'13115': u'Lo Barnechea',
                                                                        u'13116': u'Lo Espejo',
                                                                        u'13117': u'Lo Prado',
                                                                        u'13118': u'Macul',
                                                                        u'13119': u'Maip\xfa',
                                                                        u'13120': u'\xd1u\xf1oa',
                                                                        u'13121': u'Pedro Aguirre Cerda',
                                                                        u'13122': u'Pe\xf1alol\xe9n',
                                                                        u'13123': u'Providencia',
                                                                        u'13124': u'Pudahuel',
                                                                        u'13125': u'Quilicura',
                                                                        u'13126': u'Quinta Normal',
                                                                        u'13127': u'Recoleta',
                                                                        u'13128': u'Renca',
                                                                        u'13129': u'San Joaqu\xedn',
                                                                        u'13130': u'San Miguel',
                                                                        u'13131': u'San Ram\xf3n',
                                                                        u'13132': u'Vitacura'}},
                                                  u'132': {'name': u'Cordillera',
                                                           'communes': {u'13201': u'Puente Alto',
                                                                        u'13202': u'Pirque',
                                                                        u'13203': u'San Jos\xe9 de Maipo'}},
                                                  u'133': {'name': u'Chacabuco',
                                                           'communes': {u'13301': u'Colina',
                                                                        u'13302': u'Lampa',
                                                                        u'13303': u'Tiltil'}},
                                                  u'134': {'name': u'Maipo',
                                                           'communes': {u'13401': u'San Bernardo',
                                                                        u'13402': u'Buin',
                                                                        u'13403': u'Calera de Tango',
                                                                        u'13404': u'Paine'}},
                                                  u'135': {'name': u'Melipilla',
                                                           'communes': {u'13501': u'Melipilla',
                                                                        u'13502': u'Alhu\xe9',
                                                                        u'13503': u'Curacav\xed',
                                                                        u'13504': u'Mar\xeda Pinto',
                                                                        u'13505': u'San Pedro'}},
                                                  u'136': {'name': u'Talagante',
                                                           'communes': {u'13601': u'Talagante',
                                                                        u'13602': u'El Monte',
                                                                        u'13603': u'Isla de Maipo',
                                                                        u'13604': u'Padre Hurtado',
                                                                        u'13605': u'Pe\xf1aflor'}}}},
                            u'14': {'name': u'Regi\xf3n de Los R\xedos',
                                    'provinces': {u'141': {'name': u'Valdivia',
                                                           'communes': {u'14101': u'Valdivia',
                                                                        u'14102': u'Corral',
                                                                        u'14103': u'Lanco',
                                                                        u'14104': u'Los Lagos',
                                                                        u'14105': u'M\xe1fil',
                                                                        u'14106': u'Mariquina',
                                                                        u'14107': u'Paillaco',
                                                                        u'14108': u'Panguipulli'}},
                                                  u'142': {'name': u'Ranco',
                                                           'communes': {u'14201': u'La Uni\xf3n',
                                                                        u'14202': u'Futrono',
                                                                        u'14203': u'Lago Ranco',
                                                                        u'14204': u'R\xedo Bueno'}}}},
                            u'15': {'name': u'Arica y Parinacota',
                                    'provinces': {u'151': {'name': u'Arica',
                                                           'communes': {u'15101': u'Arica',
                                                                        u'15102': u'Camarones'}},
                                                  u'152': {'name': u'Parinacota',
                                                           'communes': {u'15201': u'Putre',
                                                                        u'15202': u'General Lagos'}}}}}


REGIONS = TERRITORIAL_ORGANIZATION
REGION_CHOICES = sorted((region_code, region_data['name']) for region_code, region_data in REGIONS.items())

PROVINCES = list(chain.from_iterable(d.items() for d in (region_data['provinces'] for region_data in REGIONS.values())))
PROVINCE_CHOICES = sorted(((code, province['name']) for code, province in PROVINCES), key=lambda t: t[1])

COMMUNES = chain.from_iterable(d.items() for d in (province['communes'] for code, province in PROVINCES))
COMMUNE_CHOICES = sorted(COMMUNES, key=lambda t: t[1])
